#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "global.h"
#include "log.h"

static const char rcsid[] = "iaxproxy-version: " __FILE__ " " VCS_VERSION;

int debug_level=0;
const char *log_filename = NULL, *connlog_filename = NULL;
FILE *log_file=NULL, *connlog_file=NULL;

void
open_logs(int daemonize) {
	if(log_filename) {
		if(log_file != NULL && log_file != stdout) {
			fclose(log_file);
		}

		log_file = fopen(log_filename, "a");
		if(log_file==NULL) {
			printf("Couldn't open '%s' for logging.\n", log_filename);
			if(daemonize) {
				printf("Can't log to stdout as daemon.\n");
				exit(EXIT_FAILURE);
			}
			log_file = stdout;
		}
		setlinebuf(log_file);
	}

	if(connlog_filename) {
		if(connlog_file) {
			fclose(connlog_file);
		}

		connlog_file = fopen(connlog_filename, "a");
		if(connlog_file==NULL) {
			DIE("Couldn't open connection log file '%s'.\n", connlog_filename);
		}
		setlinebuf(connlog_file);
	}
}

char *
time_string(time_t t) {
	static char timebuf[32];
	struct tm *tp;

	if (t == 0)
		time(&t);
	tp = gmtime(&t);
	assert(tp != NULL);
	strftime(timebuf, sizeof timebuf, "%Y-%m-%d %H:%M:%S %z", tp);
	return timebuf;
}
